#include <curand.h>
#include <stdint.h>
#include <stdio.h>
#include "scene.cuh"
#include "camera.cuh"

__global__ void render(uint8_t *final_img, Camera *cam) {
  //camera returns raw r/g/b(/z?) value, postprocessing (including gamma) happens per pixel in kernel here
  vect3 bruh = cam->render();
  const uint3 unnormalized_uv = ((blockDim * blockIdx) + threadIdx);
  const unsigned int img_index = (unnormalized_uv.x + (unnormalized_uv.y * blockDim.x * gridDim.x)) * 4;
  final_img[img_index] = bruh.x * 0xff;
  final_img[img_index+1] = bruh.y * 0xff;
  final_img[img_index+2] = bruh.z * 0xff;
  final_img[img_index+3] = 0xff;

}
