#ifndef SCENE_H
#define SCENE_H

#include "common.cuh"
#include "render_object.cuh"
#include "sphere.cuh"
#include "include/helper_math.h"
//#include "camera.cuh"
#include <stdint.h>

//when we get animations with multiple scenes, we'll make this a virtual function
//with array of DE objects and cam
class Scene {
  public:
    Scene(){};
    Scene(const Scene&){};
    __device__ Render_object *raycast(struct Ray ray);
    __device__ Render_object **get_objects() { return render_objs; }
    __host__ void add_render_object(Render_object *object);
  protected:
    Render_object *render_objs[16] = {nullptr}; //TODO we'll make this dynamic later
    uint8_t *image;
};

#endif
